/*!
    localForage -- Offline Storage, Improved
    Version 1.2.2
    https://mozilla.github.io/localForage
    (c) 2013-2015 Mozilla, Apache License 2.0
*/

/*
 * Includes code from:
 *
 * base64-arraybuffer
 * https://github.com/niklasvh/base64-arraybuffer
 *
 * Copyright (c) 2012 Niklas von Hertzen
 * Licensed under the MIT license.
 */

(function(){"use strict";function e(e,n){var r="";if(e)r=e.toString();if(e&&("[object ArrayBuffer]"===e.toString()||e.buffer&&"[object ArrayBuffer]"===e.buffer.toString())){var i,a=o;if(e instanceof ArrayBuffer)i=e,a+=u;else if(i=e.buffer,"[object Int8Array]"===r)a+=s;else if("[object Uint8Array]"===r)a+=c;else if("[object Uint8ClampedArray]"===r)a+=l;else if("[object Int16Array]"===r)a+=d;else if("[object Uint16Array]"===r)a+=h;else if("[object Int32Array]"===r)a+=v;else if("[object Uint32Array]"===r)a+=y;else if("[object Float32Array]"===r)a+=g;else if("[object Float64Array]"===r)a+=p;else n(new Error("Failed to get type for BinaryArray"));n(a+t(i))}else if("[object Blob]"===r){var m=new FileReader;m.onload=function(){var e=t(this.result);n(o+f+e)},m.readAsArrayBuffer(e)}else try{n(JSON.stringify(e))}catch(b){window.console.error("Couldn't convert value into a JSON string: ",e),n(null,b)}}function n(e){if(e.substring(0,a)!==o)return JSON.parse(e);var n=e.substring(m),t=e.substring(a,m),i=r(n);switch(t){case u:return i;case f:return new Blob([i]);case s:return new Int8Array(i);case c:return new Uint8Array(i);case l:return new Uint8ClampedArray(i);case d:return new Int16Array(i);case h:return new Uint16Array(i);case v:return new Int32Array(i);case y:return new Uint32Array(i);case g:return new Float32Array(i);case p:return new Float64Array(i);default:throw new Error("Unkown type: "+t)}}function r(e){var n,r,t,o,a,u=.75*e.length,f=e.length,s=0;if("="===e[e.length-1])if(u--,"="===e[e.length-2])u--;var c=new ArrayBuffer(u),l=new Uint8Array(c);for(n=0;f>n;n+=4)r=i.indexOf(e[n]),t=i.indexOf(e[n+1]),o=i.indexOf(e[n+2]),a=i.indexOf(e[n+3]),l[s++]=r<<2|t>>4,l[s++]=(15&t)<<4|o>>2,l[s++]=(3&o)<<6|63&a;return c}function t(e){var n,r=new Uint8Array(e),t="";for(n=0;n<r.length;n+=3)t+=i[r[n]>>2],t+=i[(3&r[n])<<4|r[n+1]>>4],t+=i[(15&r[n+1])<<2|r[n+2]>>6],t+=i[63&r[n+2]];if(r.length%3===2)t=t.substring(0,t.length-1)+"=";else if(r.length%3===1)t=t.substring(0,t.length-2)+"==";return t}var i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="__lfsc__:",a=o.length,u="arbf",f="blob",s="si08",c="ui08",l="uic8",d="si16",v="si32",h="ur16",y="ui32",g="fl32",p="fl64",m=a+u.length,b={serialize:e,deserialize:n,stringToBuffer:r,bufferToString:t};if("undefined"!=typeof module&&module.exports)module.exports=b;else if("function"==typeof define&&define.amd)define("localforageSerializer",function(){return b});else this.localforageSerializer=b}).call(window),function(){"use strict";function e(e){var n=this,r={db:null};if(e)for(var t in e)r[t]=e[t];return new d(function(e,t){var i=v.open(r.name,r.version);i.onerror=function(){t(i.error)},i.onupgradeneeded=function(){i.result.createObjectStore(r.storeName)},i.onsuccess=function(){r.db=i.result,n._dbInfo=r,e()}})}function n(e,n){var r=this;if("string"!=typeof e)window.console.warn(e+" used as a key, but it is not a string."),e=String(e);var t=new d(function(n,t){r.ready().then(function(){var i=r._dbInfo,o=i.db.transaction(i.storeName,"readonly").objectStore(i.storeName),a=o.get(e);a.onsuccess=function(){var e=a.result;if(void 0===e)e=null;n(e)},a.onerror=function(){t(a.error)}})["catch"](t)});return c(t,n),t}function r(e,n){var r=this,t=new d(function(n,t){r.ready().then(function(){var i=r._dbInfo,o=i.db.transaction(i.storeName,"readonly").objectStore(i.storeName),a=o.openCursor(),u=1;a.onsuccess=function(){var r=a.result;if(r){var t=e(r.value,r.key,u++);if(void 0!==t)n(t);else r["continue"]()}else n()},a.onerror=function(){t(a.error)}})["catch"](t)});return c(t,n),t}function t(e,n,r){var t=this;if("string"!=typeof e)window.console.warn(e+" used as a key, but it is not a string."),e=String(e);var i=new d(function(r,i){t.ready().then(function(){var o=t._dbInfo,a=o.db.transaction(o.storeName,"readwrite"),u=a.objectStore(o.storeName);if(null===n)n=void 0;var f=u.put(n,e);a.oncomplete=function(){if(void 0===n)n=null;r(n)},a.onabort=a.onerror=function(){i(f.error)}})["catch"](i)});return c(i,r),i}function i(e,n){var r=this;if("string"!=typeof e)window.console.warn(e+" used as a key, but it is not a string."),e=String(e);var t=new d(function(n,t){r.ready().then(function(){var i=r._dbInfo,o=i.db.transaction(i.storeName,"readwrite"),a=o.objectStore(i.storeName),u=a["delete"](e);o.oncomplete=function(){n()},o.onerror=function(){t(u.error)},o.onabort=function(e){var n=e.target.error;if("QuotaExceededError"===n)t(n)}})["catch"](t)});return c(t,n),t}function o(e){var n=this,r=new d(function(e,r){n.ready().then(function(){var t=n._dbInfo,i=t.db.transaction(t.storeName,"readwrite"),o=i.objectStore(t.storeName),a=o.clear();i.oncomplete=function(){e()},i.onabort=i.onerror=function(){r(a.error)}})["catch"](r)});return c(r,e),r}function a(e){var n=this,r=new d(function(e,r){n.ready().then(function(){var t=n._dbInfo,i=t.db.transaction(t.storeName,"readonly").objectStore(t.storeName),o=i.count();o.onsuccess=function(){e(o.result)},o.onerror=function(){r(o.error)}})["catch"](r)});return s(r,e),r}function u(e,n){var r=this,t=new d(function(n,t){if(0>e)return void n(null);else return void r.ready().then(function(){var i=r._dbInfo,o=i.db.transaction(i.storeName,"readonly").objectStore(i.storeName),a=!1,u=o.openCursor();u.onsuccess=function(){var r=u.result;if(!r)return void n(null);if(0===e)n(r.key);else if(!a)a=!0,r.advance(e);else n(r.key)},u.onerror=function(){t(u.error)}})["catch"](t)});return s(t,n),t}function f(e){var n=this,r=new d(function(e,r){n.ready().then(function(){var t=n._dbInfo,i=t.db.transaction(t.storeName,"readonly").objectStore(t.storeName),o=i.openCursor(),a=[];o.onsuccess=function(){var n=o.result;if(!n)return void e(a);else return a.push(n.key),void n["continue"]()},o.onerror=function(){r(o.error)}})["catch"](r)});return s(r,e),r}function s(e,n){if(n)e.then(function(e){n(null,e)},function(e){n(e)})}function c(e,n){if(n)e.then(function(e){l(n,e)},function(e){n(e)})}function l(e,n){if(e)return setTimeout(function(){return e(null,n)},0);else return void 0}var d="undefined"!=typeof module&&module.exports?require("promise"):this.Promise,v=v||this.indexedDB||this.webkitIndexedDB||this.mozIndexedDB||this.OIndexedDB||this.msIndexedDB;if(v){var h={_driver:"asyncStorage",_initStorage:e,iterate:r,getItem:n,setItem:t,removeItem:i,clear:o,length:a,key:u,keys:f};if("undefined"!=typeof module&&module.exports)module.exports=h;else if("function"==typeof define&&define.amd)define("asyncStorage",function(){return h});else this.asyncStorage=h}}.call(window),function(){"use strict";function e(e){var n=this,r={};if(e)for(var t in e)r[t]=e[t];r.keyPrefix=r.name+"/",n._dbInfo=r;var i=new c(function(e){if(g===y.DEFINE)require(["localforageSerializer"],e);else if(g===y.EXPORT)e(require("./../utils/serializer"));else e(l.localforageSerializer)});return i.then(function(e){return d=e,c.resolve()})}function n(e){var n=this,r=n.ready().then(function(){for(var e=n._dbInfo.keyPrefix,r=v.length-1;r>=0;r--){var t=v.key(r);if(0===t.indexOf(e))v.removeItem(t)}});return s(r,e),r}function r(e,n){var r=this;if("string"!=typeof e)window.console.warn(e+" used as a key, but it is not a string."),e=String(e);var t=r.ready().then(function(){var n=r._dbInfo,t=v.getItem(n.keyPrefix+e);if(t)t=d.deserialize(t);return t});return s(t,n),t}function t(e,n){var r=this,t=r.ready().then(function(){for(var n=r._dbInfo.keyPrefix,t=n.length,i=v.length,o=0;i>o;o++){var a=v.key(o),u=v.getItem(a);if(u)u=d.deserialize(u);if(u=e(u,a.substring(t),o+1),void 0!==u)return u}});return s(t,n),t}function i(e,n){var r=this,t=r.ready().then(function(){var n,t=r._dbInfo;try{n=v.key(e)}catch(i){n=null}if(n)n=n.substring(t.keyPrefix.length);return n});return s(t,n),t}function o(e){var n=this,r=n.ready().then(function(){for(var e=n._dbInfo,r=v.length,t=[],i=0;r>i;i++)if(0===v.key(i).indexOf(e.keyPrefix))t.push(v.key(i).substring(e.keyPrefix.length));return t});return s(r,e),r}function a(e){var n=this,r=n.keys().then(function(e){return e.length});return s(r,e),r}function u(e,n){var r=this;if("string"!=typeof e)window.console.warn(e+" used as a key, but it is not a string."),e=String(e);var t=r.ready().then(function(){var n=r._dbInfo;v.removeItem(n.keyPrefix+e)});return s(t,n),t}function f(e,n,r){var t=this;if("string"!=typeof e)window.console.warn(e+" used as a key, but it is not a string."),e=String(e);var i=t.ready().then(function(){if(void 0===n)n=null;var r=n;return new c(function(i,o){d.serialize(n,function(n,a){if(a)o(a);else try{var u=t._dbInfo;v.setItem(u.keyPrefix+e,n),i(r)}catch(f){if("QuotaExceededError"===f.name||"NS_ERROR_DOM_QUOTA_REACHED"===f.name)o(f);o(f)}})})});return s(i,r),i}function s(e,n){if(n)e.then(function(e){n(null,e)},function(e){n(e)})}var c="undefined"!=typeof module&&module.exports?require("promise"):this.Promise,l=this,d=null,v=null;try{if(!(this.localStorage&&"setItem"in this.localStorage))return;v=this.localStorage}catch(h){return}var y={DEFINE:1,EXPORT:2,WINDOW:3},g=y.WINDOW;if("undefined"!=typeof module&&module.exports)g=y.EXPORT;else if("function"==typeof define&&define.amd)g=y.DEFINE;var p={_driver:"localStorageWrapper",_initStorage:e,iterate:t,getItem:r,setItem:f,removeItem:u,clear:n,length:a,key:i,keys:o};if(g===y.EXPORT)module.exports=p;else if(g===y.DEFINE)define("localStorageWrapper",function(){return p});else this.localStorageWrapper=p}.call(window),function(){"use strict";function e(e){var n=this,r={db:null};if(e)for(var t in e)r[t]="string"!=typeof e[t]?e[t].toString():e[t];var i=new c(function(e){if(y===h.DEFINE)require(["localforageSerializer"],e);else if(y===h.EXPORT)e(require("./../utils/serializer"));else e(l.localforageSerializer)}),o=new c(function(t,i){try{r.db=v(r.name,String(r.version),r.description,r.size)}catch(o){return n.setDriver(n.LOCALSTORAGE).then(function(){return n._initStorage(e)}).then(t)["catch"](i)}r.db.transaction(function(e){e.executeSql("CREATE TABLE IF NOT EXISTS "+r.storeName+" (id INTEGER PRIMARY KEY, key unique, value)",[],function(){n._dbInfo=r,t()},function(e,n){i(n)})})});return i.then(function(e){return d=e,o})}function n(e,n){var r=this;if("string"!=typeof e)window.console.warn(e+" used as a key, but it is not a string."),e=String(e);var t=new c(function(n,t){r.ready().then(function(){var i=r._dbInfo;i.db.transaction(function(r){r.executeSql("SELECT * FROM "+i.storeName+" WHERE key = ? LIMIT 1",[e],function(e,r){var t=r.rows.length?r.rows.item(0).value:null;if(t)t=d.deserialize(t);n(t)},function(e,n){t(n)})})})["catch"](t)});return s(t,n),t}function r(e,n){var r=this,t=new c(function(n,t){r.ready().then(function(){var i=r._dbInfo;i.db.transaction(function(r){r.executeSql("SELECT * FROM "+i.storeName,[],function(r,t){for(var i=t.rows,o=i.length,a=0;o>a;a++){var u=i.item(a),f=u.value;if(f)f=d.deserialize(f);if(f=e(f,u.key,a+1),void 0!==f)return void n(f)}n()},function(e,n){t(n)})})})["catch"](t)});return s(t,n),t}function t(e,n,r){var t=this;if("string"!=typeof e)window.console.warn(e+" used as a key, but it is not a string."),e=String(e);var i=new c(function(r,i){t.ready().then(function(){if(void 0===n)n=null;var o=n;d.serialize(n,function(n,a){if(a)i(a);else{var u=t._dbInfo;u.db.transaction(function(t){t.executeSql("INSERT OR REPLACE INTO "+u.storeName+" (key, value) VALUES (?, ?)",[e,n],function(){r(o)},function(e,n){i(n)})},function(e){if(e.code===e.QUOTA_ERR)i(e)})}})})["catch"](i)});return s(i,r),i}function i(e,n){var r=this;if("string"!=typeof e)window.console.warn(e+" used as a key, but it is not a string."),e=String(e);var t=new c(function(n,t){r.ready().then(function(){var i=r._dbInfo;i.db.transaction(function(r){r.executeSql("DELETE FROM "+i.storeName+" WHERE key = ?",[e],function(){n()},function(e,n){t(n)})})})["catch"](t)});return s(t,n),t}function o(e){var n=this,r=new c(function(e,r){n.ready().then(function(){var t=n._dbInfo;t.db.transaction(function(n){n.executeSql("DELETE FROM "+t.storeName,[],function(){e()},function(e,n){r(n)})})})["catch"](r)});return s(r,e),r}function a(e){var n=this,r=new c(function(e,r){n.ready().then(function(){var t=n._dbInfo;t.db.transaction(function(n){n.executeSql("SELECT COUNT(key) as c FROM "+t.storeName,[],function(n,r){var t=r.rows.item(0).c;e(t)},function(e,n){r(n)})})})["catch"](r)});return s(r,e),r}function u(e,n){var r=this,t=new c(function(n,t){r.ready().then(function(){var i=r._dbInfo;i.db.transaction(function(r){r.executeSql("SELECT key FROM "+i.storeName+" WHERE id = ? LIMIT 1",[e+1],function(e,r){var t=r.rows.length?r.rows.item(0).key:null;n(t)},function(e,n){t(n)})})})["catch"](t)});return s(t,n),t}function f(e){var n=this,r=new c(function(e,r){n.ready().then(function(){var t=n._dbInfo;t.db.transaction(function(n){n.executeSql("SELECT key FROM "+t.storeName,[],function(n,r){for(var t=[],i=0;i<r.rows.length;i++)t.push(r.rows.item(i).key);e(t)},function(e,n){r(n)})})})["catch"](r)});return s(r,e),r}function s(e,n){if(n)e.then(function(e){n(null,e)},function(e){n(e)})}var c="undefined"!=typeof module&&module.exports?require("promise"):this.Promise,l=this,d=null,v=this.openDatabase;if(v){var h={DEFINE:1,EXPORT:2,WINDOW:3},y=h.WINDOW;if("undefined"!=typeof module&&module.exports)y=h.EXPORT;else if("function"==typeof define&&define.amd)y=h.DEFINE;var g={_driver:"webSQLStorage",_initStorage:e,iterate:r,getItem:n,setItem:t,removeItem:i,clear:o,length:a,key:u,keys:f};if(y===h.DEFINE)define("webSQLStorage",function(){return g});else if(y===h.EXPORT)module.exports=g;else this.webSQLStorage=g}}.call(window),function(){"use strict";function e(e,n){e[n]=function(){var r=arguments;return e.ready().then(function(){return e[n].apply(e,r)})}}function n(){for(var e=1;e<arguments.length;e++){var n=arguments[e];if(n)for(var r in n)if(n.hasOwnProperty(r))if(v(n[r]))arguments[0][r]=n[r].slice();else arguments[0][r]=n[r]}return arguments[0]}function r(e){for(var n in a)if(a.hasOwnProperty(n)&&a[n]===e)return!0;return!1}function t(r){this._config=n({},c,r),this._driverSet=null,this._ready=!1,this._dbInfo=null;for(var t=0;t<f.length;t++)e(this,f[t]);this.setDriver(this._config.driver)}var i="undefined"!=typeof module&&module.exports?require("promise"):this.Promise,o={},a={INDEXEDDB:"asyncStorage",LOCALSTORAGE:"localStorageWrapper",WEBSQL:"webSQLStorage"},u=[a.INDEXEDDB,a.WEBSQL,a.LOCALSTORAGE],f=["clear","getItem","iterate","key","keys","length","removeItem","setItem"],s={DEFINE:1,EXPORT:2,WINDOW:3},c={description:"",driver:u.slice(),name:"localforage",size:4980736,storeName:"keyvaluepairs",version:1},l=s.WINDOW;if("undefined"!=typeof module&&module.exports)l=s.EXPORT;else if("function"==typeof define&&define.amd)l=s.DEFINE;var d=function(e){var n=n||e.indexedDB||e.webkitIndexedDB||e.mozIndexedDB||e.OIndexedDB||e.msIndexedDB,r={};return r[a.WEBSQL]=!!e.openDatabase,r[a.INDEXEDDB]=!!function(){if("undefined"!=typeof e.openDatabase&&e.navigator&&e.navigator.userAgent&&/Safari/.test(e.navigator.userAgent)&&!/Chrome/.test(e.navigator.userAgent))return!1;try{return n&&"function"==typeof n.open&&"undefined"!=typeof e.IDBKeyRange}catch(r){return!1}}(),r[a.LOCALSTORAGE]=!!function(){try{return e.localStorage&&"setItem"in e.localStorage&&e.localStorage.setItem}catch(n){return!1}}(),r}(this),v=Array.isArray||function(e){return"[object Array]"===Object.prototype.toString.call(e)},h=this;t.prototype.INDEXEDDB=a.INDEXEDDB,t.prototype.LOCALSTORAGE=a.LOCALSTORAGE,t.prototype.WEBSQL=a.WEBSQL,t.prototype.config=function(e){if("object"==typeof e){if(this._ready)return new Error("Can't call config() after localforage has been used.");for(var n in e){if("storeName"===n)e[n]=e[n].replace(/\W/g,"_");this._config[n]=e[n]}if("driver"in e&&e.driver)this.setDriver(this._config.driver);return!0}else if("string"==typeof e)return this._config[e];else return this._config},t.prototype.defineDriver=function(e,n,t){var a=new i(function(n,t){try{var a=e._driver,u=new Error("Custom driver not compliant; see https://mozilla.github.io/localForage/#definedriver"),s=new Error("Custom driver name already in use: "+e._driver);if(!e._driver)return void t(u);if(r(e._driver))return void t(s);for(var c=f.concat("_initStorage"),l=0;l<c.length;l++){var v=c[l];if(!v||!e[v]||"function"!=typeof e[v])return void t(u)}var h=i.resolve(!0);if("_support"in e)if(e._support&&"function"==typeof e._support)h=e._support();else h=i.resolve(!!e._support);h.then(function(r){d[a]=r,o[a]=e,n()},t)}catch(y){t(y)}});return a.then(n,t),a},t.prototype.driver=function(){return this._driver||null},t.prototype.ready=function(e){var n=this,r=new i(function(e,r){n._driverSet.then(function(){if(null===n._ready)n._ready=n._initStorage(n._config);n._ready.then(e,r)})["catch"](r)});return r.then(e,e),r},t.prototype.setDriver=function(e,n,t){function a(){u._config.driver=u.driver()}var u=this;if("string"==typeof e)e=[e];return this._driverSet=new i(function(n,t){var a=u._getFirstSupportedDriver(e),f=new Error("No available storage method found.");if(!a)return u._driverSet=i.reject(f),void t(f);if(u._dbInfo=null,u._ready=null,r(a))if(l===s.DEFINE)return void require([a],function(e){u._extend(e),n()});else if(l===s.EXPORT){var c;switch(a){case u.INDEXEDDB:c=require("./drivers/indexeddb");break;case u.LOCALSTORAGE:c=require("./drivers/localstorage");break;case u.WEBSQL:c=require("./drivers/websql")}u._extend(c)}else u._extend(h[a]);else if(o[a])u._extend(o[a]);else return u._driverSet=i.reject(f),void t(f);n()}),this._driverSet.then(a,a),this._driverSet.then(n,t),this._driverSet},t.prototype.supports=function(e){return!!d[e]},t.prototype._extend=function(e){n(this,e)},t.prototype._getFirstSupportedDriver=function(e){if(e&&v(e))for(var n=0;n<e.length;n++){var r=e[n];if(this.supports(r))return r}return null},t.prototype.createInstance=function(e){return new t(e)};var y=new t;if(l===s.DEFINE)define("localforage",function(){return y});else if(l===s.EXPORT)module.exports=y;else this.localforage=y}.call(window);